﻿Public Class Form1
    ' If the TextBox doesn't contain an integer between min_value and max_value,
    ' display an error message, set focus to the TextBox, and return False.
    ' Otherwise return True and return the integer through the ByRef
    ' parameter result.
    Private Function IsValidInteger(ByRef result As Integer, ByVal txt As TextBox, ByVal field_name As String, Optional ByVal min_value As Integer = Integer.MinValue, Optional ByVal max_value As Integer = Integer.MaxValue) As Boolean
        ' Check for blank entry.
        Dim num_items_txt As String = txt.Text
        If num_items_txt.Length < 1 Then
            MessageBox.Show("Please enter " & field_name & ".")
            txt.Focus()
            Return False
        End If

        ' See if it's numeric.
        If Not IsNumeric(num_items_txt) Then
            MessageBox.Show(field_name & " must be a number.")
            txt.Select(0, num_items_txt.Length)
            txt.Focus()
            Return False
        End If

        ' Assign the value.
        Try
            result = Integer.Parse(txt.Text)
        Catch ex As Exception
            MessageBox.Show("Error in " & field_name & "." & _
                vbCrLf & ex.Message)
            txt.Select(0, num_items_txt.Length)
            txt.Focus()
            Return False
        End Try

        ' Check that the value is between min_value and max_value.
        If result < min_value Or result > max_value Then
            MessageBox.Show(field_name & " must be between " & _
                min_value.ToString & " and " & max_value.ToString & ".")
            txt.Select(0, num_items_txt.Length)
            txt.Focus()
            Return False
        End If

        ' The value is okay.
        Return True
    End Function

    ' Validate the value.
    Private Sub btnValidate_Click() Handles btnValidate.Click
        Dim the_value As Integer

        ' See if the value is valid.
        If Not IsValidInteger(the_value, txtValue, "Value", 1, 10) Then Exit Sub

        ' In a "real" application, you would perform other processing here.
        ' ...
        MessageBox.Show("OK")
    End Sub
End Class
