﻿Imports System.ComponentModel
Imports System.Globalization
Imports System.Threading

Public Class Form1
    ' Select English.
    Private Sub radEnglish_CheckedChanged() Handles radEnglish.CheckedChanged
        If Not radEnglish.Checked Then Exit Sub
        LoadAllResources(New CultureInfo("en-US"))
    End Sub

    ' Select German.
    Private Sub radGerman_CheckedChanged() Handles radGerman.CheckedChanged
        If Not radGerman.Checked Then Exit Sub
        LoadAllResources(New CultureInfo("de-DE"))
    End Sub

    ' Load resources for the form and all controls.
    Private Sub LoadAllResources(ByVal culture_info As CultureInfo)
        ' Set the current culture and UI culture.
        Thread.CurrentThread.CurrentCulture = culture_info
        Thread.CurrentThread.CurrentUICulture = culture_info

        ' Make a ComponentResourceManager.
        Dim component_resource_manager As New ComponentResourceManager(Me.GetType)

        ' Load the form's resources.
        LoadResources(Me, "$this", component_resource_manager)
    End Sub

    ' Load appropriate resources for an object and its contained controls.
    Private Sub LoadResources(ByVal parent As Control, ByVal parent_name As String, ByVal component_resource_manager As ComponentResourceManager)
        ' Load the parent's resources.
        component_resource_manager.ApplyResources(parent, parent_name)
        ToolTip1.SetToolTip(parent, component_resource_manager.GetString(parent_name & ".ToolTip"))

        ' Load each contained control's resources.
        For Each ctl As Control In parent.Controls
            LoadResources(ctl, ctl.Name, component_resource_manager)
        Next ctl
    End Sub
End Class
